/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.binding.soap.listener.incoming.servlet;

import java.io.IOException;
import java.util.logging.Logger;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.stream.XMLStreamException;

import org.apache.axiom.om.OMElement;
import org.objectweb.petals.ws.notification.WsnIsolationLayer;

/**
 * Servlet used to handle incoming WSN calls.
 *
 * @author chamerling - eBM WebSourcing
 *
 */
public class SubscriptionServiceServlet extends HttpServlet {

    private static final long serialVersionUID = 15121978L;

    private WsnIsolationLayer isolationLayer;

    private Logger logger;

    /**
     * Creates a new instance of {@link SubscriptionServiceServlet}
     */
    public SubscriptionServiceServlet(WsnIsolationLayer isolation, Logger logger) {
        super();
        this.isolationLayer = isolation;
        this.logger = logger;
    }

    /*
     * (non-Javadoc)
     *
     * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest,
     *      javax.servlet.http.HttpServletResponse)
     */
    protected void doPost(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/xml");

        logger.info("Receiving a new request on WSN subscription service");
        try {
            OMElement reply = isolationLayer.handleRequest(request);

            if (reply != null) {
                reply.serialize(response.getOutputStream());
            } else {
                logger
                        .warning("The WSN isolation layer does not returns any response...");
                // TODO : send error message
            }
        } catch (XMLStreamException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
